//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "main_dialog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

//#include "uf.h"

TMainDialog *MainDialog;

//---------------------------------------------------------------------------
__fastcall TMainDialog::TMainDialog(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMainDialog::StartButtonClick(TObject *Sender)
{
 //ShowMessage("  ");
 //StatusBarInfo->SimpleText="   " ;

        char *param;
        char defo[100]="", *substr;
        int i;
        FILE *f;
        char PTP_file[100];

 AnsiString  fstr_o="" , fstr_defo="";
 char mes[600];
 int fl_defo,fl_o;
 if (0==ParamCount()) {
   strcpy(mes,"   \n");
   strcat(mes,System::CmdLine); //LPTSTR GetCommandLine()
   Application->MessageBox(mes,"new_gpm", MB_OK);
   Application->Terminate();
   return ;
 }

        //       tmp.txt
        //     DEFO
        AnsiString dp;
        dp=Param->Caption ;
        param=dp.c_str();

  fl_defo=0;
  fl_o=0;
  for (int i=0;i<=ParamCount();i++)
  {
   if (NULL!=strstr(ParamStr(i).c_str(),"-O:"))
   {
       fl_o=1;
       fstr_o=ParamStr(i).SubString(4, ParamStr(i).Length()-3);
       //Application->MessageBox(fstr_o.c_str(),"new_gpm", MB_OK);
   }
   if ( (NULL!=strstr(ParamStr(i).c_str(),"-Defo:")) || (NULL!=strstr(ParamStr(i).c_str(),"-Defo=")) )
   {
       fl_defo=1;
       fstr_defo=ParamStr(i).SubString(7, ParamStr(i).Length()-6) ;
       //Application->MessageBox(fstr_defo.c_str(),"new_gpm", MB_OK);
   }
   if (NULL!=strstr(ParamStr(i).c_str(),"-PAUSE:")) { ; }
  }

        substr = strstr(param,"-Defo");
        if(substr == NULL)
        {
                Application->MessageBox("  :  \"-Defo= (v.18)   -Defo: (v.19)\"",
                                         "   new_gpm", MB_OK);
                return;
        }

        i=0 ;
        while( (*(substr + 6 + i) != ' ') && (*(substr + 6 + i) != '\0'))
        {
             defo[i++]=*(substr + 6 + i);
        }
        defo[i] = '\0';

//  GPM
   char str[600];
   AnsiString as ;
/*    UGS -  UGII_BASE_DIR  UGII_TEMP_DIR UGII_CAM_AUXILIARY_DIR */
/*  char *ptr;
  int errorCode = UF_initialize();
  if ( 0 == errorCode )
  {
    UF_translate_variable("UGII_BASE_DIR", &ptr);
    errorCode = UF_terminate();
    as=ptr ;
    //sprintf(str,"%s\\gpm %s",as.c_str(),param);
  }

  if (ptr==NULL) {     */
        //      UGII_BASE_DIR
        TRegistry *R = new (TRegistry);
        R->RootKey = HKEY_LOCAL_MACHINE;
        R->OpenKeyReadOnly("\\SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment");
        as = R->ReadString("UGII_BASE_DIR");
/* } else {
     as=ptr ;
  }  */

        sprintf(str,"%s\\mach\\auxiliary\\gpm %s",as.c_str(),param);
        StatusBarInfo->SimpleText=str;
        system(str);

        /*   ptp-  up- */
        PTP_file[0]='\0'; UP_file[0]='\0';
        if (fl_o==0) {
          sprintf(PTP_file,"%s.ptp",defo);
          sprintf(UP_file,"%s.up",defo);
        } else {
          strcpy(PTP_file,fstr_o.c_str()); strcat(PTP_file,".ptp\0");
          strcpy(UP_file,fstr_o.c_str()); strcat(UP_file,".up\0");
        }

        StatusBarInfo->SimpleText=PTP_file;

        // ,   GPM ptp-
        f=fopen(PTP_file,"r");
        if(f == NULL)
        {
                sprintf(str,"GPM   ptp- -> TMainDialog\n %s\\mach\\auxiliary\\gpm %s",as.c_str(),param );
                Application->MessageBox(str,"   new_gpm", MB_OK);
                return;
        }
        fclose(f);

        /*  PTP-  UP */
        SPEED_LIMIT = atoi(SpeedLimitField->Text.c_str());
        FEED_MAX = atoi(FeedMaxField->Text.c_str());
        a = atoi(AField->Text.c_str());
        circle_dist=100.0;

        /*    */
        mode_seq=0;
        if (RadioButtonStandartFree->Checked==True) mode_seq=1;

        /*        */
        mode_circle_slowdn=1;
        if (CheckCircleSlowdn->State!=cbGrayed)
           if (CheckCircleSlowdn->Checked==False) mode_circle_slowdn=0; else mode_circle_slowdn=1;
         else { ; }  

        /*     */
        mode_output=0;
        if (CheckBoxNotepad->Checked==True) mode_output=1;

        PtpToUp(PTP_file,UP_file);
        // 13 sept 2004
        reginifilesave(ComboBoxMachine->ItemIndex,SPEED_LIMIT,FEED_MAX,a,mode_seq);
        //
        Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TMainDialog::ExitButtonClick(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

int __fastcall TMainDialog::reginifilesave(int methods,float sl,float fm,float acc,int sq)
{
   char *path, *ptr;

   /* get the current path environment */
   ptr = getenv("TEMP");
   if (ptr==NULL) return (-1);

   /* set up new path */
   path = (char *) malloc(strlen(ptr)+30);
   strcpy(path,ptr);
   strcat(path,"\\");
   AnsiString inifile;
   inifile = ExtractFileName(Application->ExeName);
   inifile = ChangeFileExt(inifile,".ini");
   strcat(path,inifile.c_str());

   FILE *f=fopen(path,"w");
   if (f==NULL) return (-1);

   try
   {
   TIniFile *ini;
   ini= new TIniFile (path);
   ini->WriteInteger("Form","Methods",methods);
   ini->WriteFloat("Form","SPEED_LIMIT",sl);
   ini->WriteFloat("Form","FEED_MAX",fm);
   ini->WriteFloat("Form","ACCELERATION",acc);
   ini->WriteFloat("Form","SEQNO",sq);
   }
   catch (Exception &exception)
   {
     /* Application->ShowException(&exception);*/
   }
  return (0);
}
int __fastcall TMainDialog::reginifileopen(int *methods,float *sl,float *fm,float *acc,int *sq)
{
   char *path, *ptr;

   /* get the current path environment */
   ptr = getenv("TEMP");
   if (ptr==NULL) return (-1);

   /* set up new path */
   path = (char *) malloc(strlen(ptr)+30);
   strcpy(path,ptr);
   strcat(path,"\\");
   AnsiString inifile;
   inifile = ExtractFileName(Application->ExeName);
   inifile = ChangeFileExt(inifile,".ini");
   strcat(path,inifile.c_str());

   FILE *f=fopen(path,"r");
   if (f==NULL) return (-1);

   try
   {
   TIniFile *ini;
   ini= new TIniFile (path);
   *methods=ini->ReadInteger("Form","Methods",2);
   *sl=ini->ReadFloat("Form","SPEED_LIMIT",100);
   *fm=ini->ReadFloat("Form","FEED_MAX",1200);
   *acc=ini->ReadFloat("Form","ACCELERATION",50);
   *sq=ini->ReadFloat("Form","SEQNO",0);
   }
   catch (Exception &exception)
   {
     /* Application->ShowException(&exception);*/
   }

  return (0);
}

void __fastcall TMainDialog::FormCreate(TObject *Sender)
{
  int i,ms,sq; float sp,fm,acc;
  i=reginifileopen(&ms,&sp,&fm,&acc,&sq);
  if (i<0) {
   ms=2;
   sp=100;
   fm=1200;
   acc=50;
   sq=0;
  }

  ComboBoxMachine->ItemIndex=ms;
  mode_machine=ms;
  SpeedLimitField->Text=FloatToStr(sp);
  FeedMaxField->Text=FloatToStr(fm);
  AField->Text=FloatToStr(acc);

  if (sq==0) {
      RadioButtonStandartH33->Checked=True;
      RadioButtonStandartFree->Checked=False;
  } else {
      RadioButtonStandartH33->Checked=False;
      RadioButtonStandartFree->Checked=True;
  }

  CheckBoxNotepad->Checked=False;
  CheckCircleSlowdn->Checked=True;
}
//---------------------------------------------------------------------------

void __fastcall TMainDialog::ComboBoxMachineChange(TObject *Sender)
{
  int p1;
  p1=ComboBoxMachine->ItemIndex;
  mode_machine=p1;

  switch (p1) {
  case 1 :
    // -9
    SpeedLimitField->Text="50";
    FeedMaxField->Text="900";
    AField->Text="5";
    RadioButtonStandartH33->Checked=False;
    RadioButtonStandartFree->Checked=True;
    CheckCircleSlowdn->Checked=True;
   break;
  case 2 :
    // -17
    SpeedLimitField->Text="100";
    FeedMaxField->Text="1200";
    AField->Text="50";
    RadioButtonStandartH33->Checked=True;
    RadioButtonStandartFree->Checked=False;
    CheckCircleSlowdn->Checked=True;
   break;
  case 3 :
    // 613
    SpeedLimitField->Text="50";
    FeedMaxField->Text="1000";
    AField->Text="5";
    RadioButtonStandartH33->Checked=True;
    RadioButtonStandartFree->Checked=False;
    CheckCircleSlowdn->Checked=True;
   break;
  case 4 :
    // 6552
    SpeedLimitField->Text="100";
    FeedMaxField->Text="1000";
    AField->Text="50";
    RadioButtonStandartH33->Checked=True;
    RadioButtonStandartFree->Checked=False;
    CheckCircleSlowdn->Checked=True;
   break;
   default :
    // NONE
    SpeedLimitField->Text="100";
    FeedMaxField->Text="1200";
    AField->Text="50";
    RadioButtonStandartH33->Checked=True;
    RadioButtonStandartFree->Checked=False;
    CheckCircleSlowdn->Checked=True;
   }


}
//---------------------------------------------------------------------------
void __fastcall TMainDialog::Image1DblClick(TObject *Sender)
{
 Application->MessageBox("   :  . .\n  . :  \n  : 1998 .",
       "  'new_gpm' .....", MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TMainDialog::SpeedLimitFieldChange(TObject *Sender)
{
        int tmp ;
        tmp=abs(atoi(SpeedLimitField->Text.c_str()));
        if (tmp==0) tmp=20 ;
        SpeedLimitField->Text=tmp;
}
//---------------------------------------------------------------------------

void __fastcall TMainDialog::FeedMaxFieldChange(TObject *Sender)
{
       int tmp ;
       tmp=abs(atoi(FeedMaxField->Text.c_str()));
       if (tmp==0) tmp=240 ;
       FeedMaxField->Text=tmp;
}
//---------------------------------------------------------------------------

void __fastcall TMainDialog::AFieldChange(TObject *Sender)
{
       int tmp ;
       tmp=abs(atoi(AField->Text.c_str()));
       if (tmp==0) tmp=1 ;
       AField->Text=tmp;
}
//---------------------------------------------------------------------------


