//---------------------------------------------------------------------------

#ifndef main_dialogH
#define main_dialogH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TMainDialog : public TForm
{
__published:	// IDE-managed Components
        TButton *StartButton;
        TButton *ExitButton;
        TComboBox *ComboBoxMachine;
        TLabel *Label4;
        TGroupBox *GroupBox1;
        TLabel *Label2;
        TEdit *FeedMaxField;
        TLabel *Label1;
        TEdit *SpeedLimitField;
        TLabel *Label3;
        TEdit *AField;
        TImage *Image1;
        TGroupBox *GroupBox2;
        TRadioButton *RadioButtonStandartH33;
        TRadioButton *RadioButtonStandartFree;
        TStatusBar *StatusBarInfo;
        TCheckBox *CheckBoxNotepad;
        TLabel *Param;
        TCheckBox *CheckCircleSlowdn;
        TLabel *Label5;
        void __fastcall StartButtonClick(TObject *Sender);
        void __fastcall ExitButtonClick(TObject *Sender);
        void __fastcall PtpToUp(char *file1,char *file2);
        void __fastcall feed_convert(int a,int b,char *c);
        void __fastcall feed_del(char *kadr);
        int  __fastcall otkat(int j);
        void __fastcall tangent(float a,float b,float *c,float *d);
        void __fastcall analiz(char *curr,char *next);
        int  __fastcall read_word(char *a, char b, char *c);
        void __fastcall replace_word(char *a,char b,char *c);
        //
        void __fastcall print_error(int err,char *mes);
        float __fastcall tangentn(float i,float j,float *xk,float *yk,int tp);
        float __fastcall EQ_sign (float s);
        int __fastcall none_methods (void);
        //
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall ComboBoxMachineChange(TObject *Sender);
        void __fastcall Image1DblClick(TObject *Sender);
        void __fastcall SpeedLimitFieldChange(TObject *Sender);
        void __fastcall AFieldChange(TObject *Sender);
        void __fastcall FeedMaxFieldChange(TObject *Sender);
        
private:
        char UP_file[200];
        int SPEED_LIMIT;       /*   
			             (/)*/
        int FEED_MAX;          /*   
			            (/)*/
        int a;                 /*  (  *) */
        int acenter;           /*   */
        char PLANE[10];/*    */
        int G;      /*  G=2 -     ;
			G=3 -      */
        int flag;

        struct post{char kadr[70]; /*  */
		    int feed;      /*  */
		    float span;    /*  */
		    }P[20];
        int i;   /*     P */
        long int k; /*   */
        int feed; /*    curr */
        int old_f; /*    */
        int mode; /*  */
        float SUMX,SUMY,SUMZ;
        char s_curr[200],*curr,s_next[200],*next;
        FILE *input,*out;

public:		// User declarations
        __fastcall TMainDialog(TComponent* Owner);
        int mode_machine; /* - */
        int mode_seq; /*   */
        int mode_output;  /*      */
        int mode_circle_slowdn ; /*     */
        float circle_dist;  /*        */
        int __fastcall reginifilesave(int methods,float sl,float fm,float acc,int sq);
        int __fastcall reginifileopen(int *methods,float *sl,float *fm,float *acc,int *sq);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainDialog *MainDialog;
//---------------------------------------------------------------------------
#endif
